

	/*---------------------------------------------------------------------------------*\
	|										    |
	| This is the guts of the generator.  I haven't documented what much of this code   |
	| does, but it's pretty self-explanatory.  However, if you don't know what this     |
	| stuff does I wouldn't suggest editing too much. 				    |
	|                                                                                   |
	\*---------------------------------------------------------------------------------*/

function create(form) {

	// This handles rom sizes
	var P1hexedsize = add_zero_sizes(form.p1size.value);
	var P2hexedsize = add_zero_sizes(form.p2size.value);
	var P3hexedsize = add_zero_sizes(form.p3size.value);
	var S1hexedsize = add_zero_sizes(form.s1size.value);
	var C1hexedsize = add_zero_sizes(form.c1size.value);
	var C2hexedsize = add_zero_sizes(form.c2size.value);
	var C3hexedsize = add_zero_sizes(form.c3size.value);
	var C4hexedsize = add_zero_sizes(form.c4size.value);
	var C5hexedsize = add_zero_sizes(form.c5size.value);
	var C6hexedsize = add_zero_sizes(form.c6size.value);
	var C7hexedsize = add_zero_sizes(form.c7size.value);
	var C8hexedsize = add_zero_sizes(form.c8size.value);
	var M1dhexedsize = add_zero_sizes(form.m1dsize.value);
	var M1hexedsize = add_zero_sizes(form.m1size.value);
	var V1hexedsize = add_zero_sizes(form.v1size.value);
	var V2hexedsize = add_zero_sizes(form.v2size.value);
	var V3hexedsize = add_zero_sizes(form.v3size.value);
	var V4hexedsize = add_zero_sizes(form.v4size.value);
	var V5hexedsize = add_zero_sizes(form.v5size.value);

name_gen(form)
errorchk(form);

var continuecreation = "TRUE";
if (stop_alertonstart == 0)
{
	if (form.errors.value != "")//&&(document.gen.errchk.checked != ""))
	{
		var agree=confirm(document.lang.cnferr.value);
		if (!agree) continuecreation = "FALSE";
	} else {
		alert(document.lang.cnfcrt.value);
	}
}

if (continuecreation == "TRUE")
{

	/*------------------------------------------------------------------------------------*\
	|					 					       |
	| All of the following code is for outputting Final Burn Alpha Drivers  This is the    |
	| most complete and correct part of the generator.  FBA drivers made by the	       |
	| Generator should be nearly perfect.  You may find that they are almost identical     |
	| to what the FBA team themselves would include in d_neogeo.cpp                        |
	|					 					       |
	\*------------------------------------------------------------------------------------*/

if (form.picker.value == "fba")
{
	var fba_version = form.fba_version.value;

	var additional = "";
	if (document.gen.bootleg.checked != "")
		additional += " (Bootleg)";
	if (document.gen.proto.checked != "")
		additional += " (Prototype)";

	form.fbagen.value ="// " + form.realname.value + additional + "\n\n";
	form.fbagen.value +="static struct BurnRomInfo " + form.setname.value + "RomDesc[] = {\n";

	var prg_num = "0x10";
	var srm_num = "1";
	var gfx_num = "1";
	var mdrm_num = "0x10";
	var mrm_num = "0x10";
	var snd_num = "2";

	if (fba_version == "new")
	{
		prg_num = "1 | BRF_ESS | BRF_PRG ";
		srm_num = "2 | BRF_GRA ";
		gfx_num = "3 | BRF_GRA ";
		mdrm_num = "4 | BRF_ESS | BRF_PRG ";
		mrm_num = "0 | BRF_PRG | BRF_OPT ";
		snd_num = "5 | BRF_SND ";
	}

	var beginning_space = "";
	if (fba_version == "new")
		beginning_space = " ";

/*------------------------------- P1 Output -------------------------------------- */

	var nums = 0

	n1=0
	var nums = n1
	var p1crc = "0x" + form.p1crc.value;
	if (p1crc.length < 9) p1crc = "0";

	form.fbagen.value +="	{" + beginning_space + "\"" + p1romname + "\", 0x" + P1hexedsize + ", " + p1crc +  ", " + prg_num + "}, //  " + nums + " 68K code\n";
//	form.fbagen.value += fba_gen(beginning_space, p1romname, P1hexedsize, p1crc, prg_num, nums, "68K code");


/*------------------------------- P2 Output -------------------------------------- */

	if (document.gen.chxbxp2.checked != "")
	{
		n1=n1+1
		var nums = n1
		var p2crc = "0x" + form.p2crc.value;
		if (p2crc.length < 9) p2crc = "0";
		form.fbagen.value +="	{" + beginning_space + "\"" + p2romname + "\", 0x" + P2hexedsize + ", " + p2crc + ", " + prg_num + "}, //  " + nums + "\n";
//		form.fbagen.value += fba_gen(beginning_space, p2romname, P2hexedsize, p2crc, prg_num, nums, "");
	}

/*------------------------------- P3 Output -------------------------------------- */


	if (document.gen.chxbxp3.checked != "")
	{
		n1=n1+1
		var nums = n1
		var p3crc = "0x" + form.p3crc.value;
		if (p3crc.length < 9) p3crc = "0";
		form.fbagen.value +="	{" + beginning_space + "\"" + p3romname + "\", 0x" + P3hexedsize + ", " + p3crc + ", " + prg_num + "}, //  " + nums + "\n";
	}

/*------------------------------- S1 Output -------------------------------------- */

	if (document.gen.chxbxs1.checked != "")
	{
		n1=n1+1
		var nums= n1

		var s1crc = "0x" + form.s1crc.value;
		if (s1crc.length < 9) s1crc = "0";

		form.fbagen.value +="\n	{" + beginning_space + "\"" +  s1romname + "\", 0x" + S1hexedsize + ", " + s1crc +  ",    " + srm_num + "},"; //  " + nums + " Text data\n";
//		form.fbagen.value += fba_gen(beginning_space, s1romname, S1hexedsize, s1crc, srm_num, nums, "");

		if (fba_version == "new")
			form.fbagen.value += "			 //  " + nums + " Text data\n";
		else
			form.fbagen.value += " //  " + nums + " Text data\n";

	}

/*------------------------------- C Output --------------------------------------- */

	for (var i = 1; i < 9; i++)
	{
		if (form["chxbxc" + i].checked != false)
		{
			n1=n1+1;

			var c_crc = "0x" + form["c" + i + "crc"].value;
			if (c_crc.length < 9) c_crc = "0";

			var name = c1romname;
			var size = C1hexedsize;
			if (i == 1) form.fbagen.value += "\n";
			if (i == 2) { name = c2romname; size = C2hexedsize;}
			if (i == 3) { name = c3romname; size = C3hexedsize;}
			if (i == 4) { name = c4romname; size = C4hexedsize;}
			if (i == 5) { name = c5romname; size = C5hexedsize;}
			if (i == 6) { name = c6romname; size = C6hexedsize;}
			if (i == 7) { name = c7romname; size = C7hexedsize;}
			if (i == 8) { name = c8romname; size = C8hexedsize;}


			form.fbagen.value +="	{" + beginning_space + "\"" +  name + "\", 0x" + size + ", " + c_crc +  ",    " + gfx_num + "},"; //  " + nums + " Sprite data\n";

			if (fba_version == "new")
				form.fbagen.value += "			 //  " + n1;
			else
				form.fbagen.value += " //  " + n1;

			if (i==1) form.fbagen.value += " Sprite data";
			form.fbagen.value += "\n";

			/*  kotm2 and sengoku2 fix (FBA doesn't ignore 512kb C roms when doing swap C so it crashes */
			/*  this is only required for older versions of FBA as the newer versions have fixed this   */
			if ((fba_version == "old")&&(i == 4))
			{
				if ((document.gen.swapc.checked !="") && (document.gen.chxbxc5.checked == "") && (document.gen.chxbxc6.checked == ""))
				{
					if ((document.gen.chxbxc7.checked == "") && (document.gen.c3size.value == "524288") && (document.gen.c4size.value == "524288"))
					{
						if ((document.gen.c1size.value == "2097152") && (document.gen.c2size.value == "2097152"))
						{
	   						form.fbagen.value +="	{\"" + c4romname + "\", 0x" + C4hexedsize + ", 0x" + form.c4crc.value +  ",    " + gfx_num + "}, //  " + n1 + " Double C4 (Fixes Swap C)\n";
						}
					}
				}
			}

		}
	}

/*------------------------------- M1 Output -------------------------------------- */

	if (document.gen.chxbxm1d.checked != "")
	{
		n1=n1+1;
		var nums = n1;

		var m1dcrc = "0x" + form.m1dcrc.value;
		if (m1dcrc.length < 9) m1dcrc = "0";

		form.fbagen.value +="\n	{" + beginning_space + "\"" + m1dromname + "\", 0x" + M1dhexedsize + ", " + m1dcrc +  ", " + mdrm_num + "}, //  " + nums + " Z80 code";

		if (document.gen.chxbxm1.checked != "")
			form.fbagen.value += " (decrypted)\n";
		else
			form.fbagen.value += " \n";
	}

	if (document.gen.chxbxm1.checked != "")
	{
		if (fba_version == "new")
		{
			n1=n1+1
			var nums = n1
		}

		var m1crc = "0x" + form.m1crc.value;
		if (m1crc.length < 9) m1crc = "0";

		form.fbagen.value +="	{" + beginning_space + "\"" + m1romname + "\",  0x" + M1hexedsize + ", " + m1crc +  ", " + mrm_num + "}, //  " + nums + " Z80 code\n";
	}

/*------------------------------- V Output -------------------------------------- */

	var fba_vs_loaded = 0;

	for (var i = 1; i < 6; i++)
	{
		if (document.gen["chxbxv" + i].checked != "")
		{
			if (fba_vs_loaded == 0) { form.fbagen.value += "\n"; fba_vs_loaded = 1;}
	
			n1=n1+1;
	
			var v_crc = "0x" + form["v" + i + "crc"].value;
			if (v_crc.length < 9) v_crc = 0;
	
			var name = v1romname;
			var size = V1hexedsize;
			if (i == 2){ name = v2romname; size = V2hexedsize;}
			if (i == 3){ name = v3romname; size = V3hexedsize;}
			if (i == 4){ name = v4romname; size = V4hexedsize;}
			if (i == 5){ name = v5romname; size = V5hexedsize;}
	
			form.fbagen.value +="	{" + beginning_space + "\"" + name + "\", 0x" + size + ", " + v_crc +  ",    ";
	
			if (fba_version == "new")
			{
				if ((name.slice(4,7) == "v21")||(name.slice(4,7) == "v22")||(name.slice(4,7) == "v23")||(name.slice(4,7) == "v24"))
				{
					form.fbagen.value += "6 | BRF_SND ";
				} else {
					form.fbagen.value += snd_num;
				}

				form.fbagen.value += "},			 //  " + n1;
			}
			else
				form.fbagen.value += snd_num + "}, //  " + n1;

				if (i==1) form.fbagen.value += " Sound data";
				form.fbagen.value += "\n";
		}
	}

/*------------------------------ End Output -------------------------------------- */

	form.fbagen.value +="}; \n\nSTDROMPICKEXT(" + form.setname.value + ", " + form.setname.value + ", neogeo); \nSTD_ROM_FN(" + form.setname.value + ");\n";

/*------------------------------- Pulstar fix ------------------------------------ 

	//  This setting is required only by PULSTAR, so I'm leaving it out for now 

	if (form.pulstar.value !="")
	{
		form.fbagen.value +="\n	nNeoSRAMProtection = 0x035A;"
	}

---------------------------------------------------------------------------------- */
	var enable_textromfix = 0;
	if ((document.gen.textromfix.checked != "") && (document.gen.chxbxs1.checked == ""))
	{
		enable_textromfix = 1;
	}


	if ((enable_textromfix == 1) || ((document.gen.GfxKey.value !="") && (form.criptsel.value != "")))
	{
		form.fbagen.value +="\nstatic int " + form.setname.value + "Init()\n{";
 	}

	if (enable_textromfix == 1)
	{
		form.fbagen.value +="\n	nNeoTextROMSize = 0x080000;";
	}

	if ((form.criptsel.value != "") && (document.gen.GfxKey.value !=""))
	{
		form.fbagen.value +="\n	nNeoProtectionXor = 0x" + form.GfxKey.value + ";";
	}

	if ((enable_textromfix == 1) || ((document.gen.GfxKey.value != "") && (form.criptsel.value != "")))
	{
		form.fbagen.value +="\n	return NeoInit();\n}\n";
	}

	form.fbagen.value +="\nstruct BurnDriver BurnDrv" + form.setname.value + " = {\n";


 	if (form.parentname.value =="")
	{
		var parentname = "NULL";
 	}

	if (form.parentname.value !="")
	{
		var parentname = "\""+form.parentname.value+"\"";
	}

	var year = "NULL";

	if ((form.yearname.value != "") && (form.yearname.value != "NULL"))
	{
		year = "\"" + form.yearname.value + "\"";
	}

	var notes = "NULL";

	if ((form.notesname.value =="")||(form.notesname.value == document.lang.noneop.value)||(form.notesname.value =="NULL"))
	{
		notes = "NULL";
	} else {     
		notes ="\"" + form.notesname.value + "\"";
	}

	var developer = "NULL";

	if ((form.devname.value == "")||(form.devname.value == "NULL"))
	{
		developer = "NULL";
	} else {
		developer = "\"" + form.devname.value + "\"";
	}

	if (fba_version == "old")
	{
		form.fbagen.value +="\n	{\"" + form.setname.value + "\", \"" + form.realname.value + "\", ";
		form.fbagen.value += notes + ", " + developer + ", \"Neo Geo\", " + year + ", ";
		form.fbagen.value +=parentname + ", \"neogeo\"},\n";
	}

	if (fba_version == "new")
	{
		form.fbagen.value += "	\"" + form.setname.value + "\", " + parentname + ", \"neogeo\", " + year + ",\n";
		form.fbagen.value += "	\"" + form.realname.value + "\\0\", " + notes + ", " + developer + ", \"Neo Geo\",\n";

		if ((form.non_latin_text.value == "")||(form.non_latin_text.value == "null")) {
			var unicode_name = "NULL";
		} else {
			var unicode_name = "L\"" + form.non_latin_text.value + "\\0\"";
		}

		form.fbagen.value += "	" + unicode_name + ", NULL, NULL, NULL,\n";
							//    What do these do?
	}

	form.fbagen.value +="	"; 

	if (document.gen.works.checked != "")
	{
		form.fbagen.value +=form.works.value;
	}

	if (document.gen.proto.checked != "")
	{
		if (document.gen.works.checked)
			form.fbagen.value +=" | ";

		form.fbagen.value +=form.proto.value;
	}

	if (document.gen.bootleg.checked != "")
	{
		if ((document.gen.proto.checked != "") || (document.gen.works.checked != ""))
			form.fbagen.value += " | ";
		form.fbagen.value +=form.bootleg.value
	}

	if ((document.gen.proto.checked == "") && (document.gen.works.checked == "") && (document.gen.bootleg.checked == ""))
	{
		form.fbagen.value +="0"; // Changed from NULL (NULL gives warning message in mingw)
	}

	if (document.gen.parentname.value != "NULL")
	{
		form.fbagen.value +=form.bdfclone.value;
	}

	/* This value is for the number of players -- Hidden for now as Neo-Geo only allows 2 players (AFAIK) */
	var player_num = "2";

	/* This value is to change what system is being emulated -- Disabled - The generator supports NeoGeo only */
	var system_emulated = "HARDWARE_SNK_NEOGEO";

	form.fbagen.value+=", " + player_num + ", " + system_emulated;

	if ((form.criptsel.value != "") && (document.gen.GfxKey.value !=""))
	{
		form.fbagen.value +=form.criptsel.value;
	}

	if (document.gen.swapc.checked != "")
	{
		form.fbagen.value +=form.swapc.value;
	}

	if (document.gen.swapp.checked != "")
	{
		form.fbagen.value +=form.swapp.value;
	}

	if (document.gen.swapv.checked != "")
	{
		form.fbagen.value +=form.swapv.value;
	}

	if (document.gen.sram.checked != "")
	{
		form.fbagen.value +=form.sram.value;
	}

	if (document.gen.alttxt.checked != "")
	{
		form.fbagen.value += " | HARDWARE_SNK_ALTERNATE_TEXT";
	}

	if (form.controls.value == "neotrackball")
	{
		form.fbagen.value +=" | HARDWARE_SNK_TRACKBALL";
	}

	if (form.controls.value == "neomahjong")
	{
		form.fbagen.value +=" | HARDWARE_SNK_MAHJONG";
	}

	if (form.controls.value == "neopaddle")
	{
		form.fbagen.value +=" | HARDWARE_SNK_PADDLE";
	}

	if ((document.gen.gambling.checked != "") && (form.controls.value == "neogeo"))
	{
		form.fbagen.value +=" | HARDWARE_SNK_GAMBLING";
	}

	form.fbagen.value +=",\n	NULL, " + form.setname.value + "RomInfo, " + form.setname.value + "RomName, " + form.controls.value + "InputInfo, " + form.controls.value + "DIPInfo,\n";

	if (((form.criptsel.value != "") && (document.gen.GfxKey.value != "")) || (enable_textromfix == 1))
	{
		form.fbagen.value += "	" + form.setname.value + "Init";
	} else {
		form.fbagen.value += "	NeoInit";
	}

	form.fbagen.value +=", NeoExit, NeoFrame, NeoRender, NeoScan, &NeoRecalcPalette,\n";

	var screenwidth  = "nNeoScreenWidth";
	var screenheight = "224";
	var screenratio  = "4, 3";

	form.fbagen.value +="	" + screenwidth + ", " + screenheight + ", " + screenratio + "\n};\n";
  }
}






















	/*-------------------------------------------------------------------------------------*\
	|					 						|
	| All of the following code is for outputting Nebula/Kawaks .dat files.   This		|
	| function should be able to output nearly perfect dat drivers for most of the newer	|
	| games and many of the older games too.               					|
	|											|
	\*-------------------------------------------------------------------------------------*/


if (form.picker.value == "nebula")
{

	form.fbagen.value ="%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%\n\n";

/*--------- Header Output -----*/

	form.fbagen.value +="System: NEO\n";			// The system being emulated-  Always "NEO" (Neo-Geo)
	form.fbagen.value +="RomName: " + form.setname.value;	// The rom's name (ZIP) (Example: kof2000)
	form.fbagen.value +="\nGame: " + form.realname.value;	// The game's name (Example: King of Fighters)

	if (document.gen.bootleg.checked != "")
	{
		form.fbagen.value += " (Bootleg)"
	}
	if (document.gen.proto.checked != "")
	{
		form.fbagen.value += " (Prototype)"
	}

	form.fbagen.value +="\n"

	if ((form.bdfclone.value != "") && (form.parentname.value !=""))
	{
		form.fbagen.value +="Parent: " + form.parentname.value + "\n"; // The parent rom (if there is one)
	}

//--------- P label -----------//

	form.fbagen.value +="\n[Program]\n";

//--------- P1 Output ---------//

	if (document.gen.swapp.checked != "")
	{
		var swapp = 1;
	} else {
		var swapp = 0;
	}

	if (document.gen.chxbxp1.checked != "")
	{
		if (document.gen.swapp.checked != "")
		{
			var p1zero = 100000
		} else {
			var p1zero = 0
		}

		var p1crc = form.p1crc.value;
		if (p1crc.length < 7) p1crc = "0";

		form.fbagen.value += p1romname + "," + p1zero + "," + P1hexedsize + "," + p1crc + "," + swapp + "\n";
	}

//--------- P2 Output ---------//

	if (document.gen.chxbxp2.checked != "")
	{
		var p2crc = form.p2crc.value;
		if (p2crc.length < 7) p2crc = "0";

		form.fbagen.value += p2romname + "," + P1hexedsize + "," + P2hexedsize + "," + p2crc + ",0\n";
	}

//--------- P3 Output ---------//

	if (document.gen.chxbxp3.checked != "")
	{
		var p3crc = form.p3crc.value;
		if (p3crc.length < 7) p3crc = "0";

		var nbp3sze=eval(form.p1size.value)+eval(form.p2size.value);
		nbp3sze=toHex(nbp3sze);

		form.fbagen.value += p3romname + "," + nbp3sze + "," + P3hexedsize + "," + p3crc + ",0\n";
	}

//--------- Some Vars ---------//

	var criptsel = "0";

	if ((form.criptsel.value == " | HARDWARE_SNK_ENCRYPTED_A") && (document.gen.GfxKey.value !=""))
	{
		var criptsel = "1";
	}
	if ((form.criptsel.value == " | HARDWARE_SNK_ENCRYPTED_B") && (document.gen.GfxKey.value !=""))
	{
		var criptsel = "2";
	}

	var gfxkey = "0";

	if ((form.criptsel.value != "") && (document.gen.GfxKey.value !=""))
	{
		var gfxkey = form.GfxKey.value;
	}

//--------- S Label -----------//

	form.fbagen.value +="\n[Text]\n"

//--------- S1 Output ---------//

	if ((document.gen.chxbxs1.checked != "") && (criptsel == "0") && (gfxkey == "0"))
	{
		if (document.gen.chxbxs1.checked != "")
		{
			var s1crc = form.s1crc.value;
			if (s1crc.length < 7) s1crc = "0";

			var s1zero = 0;
			form.fbagen.value += s1romname + "," + s1zero + "," + S1hexedsize + "," + s1crc + ",0\n";
		}
	}

//--------- M Label -----------//

	form.fbagen.value +="\n[Z80]\n"

//--------- M1 Output ---------//

	if (document.gen.chxbxm1.checked != "")
	{
		var m1crc = form.m1crc.value;
		if (m1crc.length < 7) m1crc = "0";

		form.fbagen.value += m1romname + ",0," + M1hexedsize + "," + m1crc +  ",0\n";
	}

	if (document.gen.chxbxm1d.checked != "")
	{
		var m1dcrc = form.m1dcrc.value;
		if (m1dcrc.length < 7) m1dcrc = "0";
		form.fbagen.value += m1dromname + ",0," + M1dhexedsize + "," + m1dcrc +  ",0\n";
	}

//--------- V Math ------------//

	var v1=eval(form.v1size.value)
	var v2=eval(form.v2size.value)
	var v2total=toHex(v1+v2)
	var v3=eval(form.v3size.value)
	var v3total=toHex(v1+v2+v3)
	var v4=eval(form.v4size.value)
	var v4total=toHex(v1+v2+v3+v4)

//--------- V Label -----------//

	form.fbagen.value +="\n[Samples]\n"

//--------- V Output ---------//

	for (var i = 1; i < 6; i++)
	{
		if (form["chxbxv" + i].checked != false)
		{
			var v_crc = form["v" + i + "crc"].value;
			if (v_crc.length < 7) v1crc = 0;

			var size = V1hexedsize;
			var name = v1romname;
			var offset = 0;

			if (i == 2) {name = v2romname; offset = V1hexedsize; size = V2hexedsize;}
			if (i == 3) {name = v3romname; offset = v2total; size = V3hexedsize;}
			if (i == 4) {name = v4romname; offset = v3total; size = V4hexedsize;}
			if (i == 5) {name = v5romname; offset = v4total; size = V5hexedsize;}

			form.fbagen.value += name + "," + offset + "," + size + "," + v_crc +  ",0\n";
		}
	}

//--------- C Math ------------//

	var C1=eval(form.c1size.value)
	var C2=eval(form.c2size.value)

/*---------------------------------*/

	var Ct1=((C1+C2)/16)

	if (document.gen.swapc.checked !="")
  	{
		Ct1=((C1)/16);
	}

	var C2total=toHex(C1+C2)

	if (document.gen.swapc.checked !="")
	{
		C2total=toHex(C1);
	}

	var c3total=(toHex(Ct1)+1)

/*---------------------------------*/

	var C3=eval(form.c3size.value)
	var C4=eval(form.c4size.value)

/*---------------------------------*/

	var c3swap = "0"

	if (document.gen.swapc.checked != "")
	{
		if (form.c3size.value != eval(2097152))
    		{
			var c3swap = "0";
		} else {
			var c3swap = "2";
		}
	}

	var c4swap = "0";

	if (document.gen.swapc.checked != "")
	{
		if (form.c4size.value != eval(2097152))
    		{
			var c4swap = "0";
		} else {
			var c4swap = "2";
		}
	}

/*---------------------------------*/

	var C4total=toHex(C1+C2+C3+C4);
	var Ct2=((C1+C2+C3+C4)/16);
	var C5total=(toHex(Ct2)+1);

/*---------------------------------*/

	var C5=eval(form.c5size.value);
	var C6=eval(form.c6size.value);

/*---------------------------------*/


	var C6total=toHex(C1+C2+C3+C4+C5+C6);
	var Ct3=((C1+C2+C3+C4+C5+C6)/16);
	var C7total=(toHex(Ct3)+1);

//--------- C Label -----------//

	form.fbagen.value +="\n[Graphics]\n";

//------ C Swapped Games -------//

	var Cs_swapped = 0;

	if ((form.setname.value == "aof")||(form.setname.value == "fatfury2")||(form.setname.value == "kotm2")||(form.setname.value == "wh1")||(form.setname.value == "wh1h")||(form.setname.value == "3countb")||(form.setname.value == "sengoku2")||(form.setname.value == "ssideki") ||(form.setname.value == "viewpoin"))
	{
		Cs_swapped = 1;
	}

//--------- C1 Output ---------//

	var c1swap = "0";

	if ((Cs_swapped != 0) && (document.gen.swapc.checked != "") && (form.c1size.value == "2097152") && (form.c2size.value == "2097152"))
	{
		if ((document.gen.chxbxc1.checked != "")&&(document.gen.chxbxc2.checked != ""))
		{
			c1swap = "2";
		}
	}

	if (document.gen.chxbxc1.checked != "")
	{
		var c1crc = form.c1crc.value;
		if (c1crc.length < 7) c1crc = "0";

		form.fbagen.value += c1romname + ",0," + C1hexedsize + "," + c1crc +  "," + c1swap + "\n";
	}

//--------- C2 Output ---------//


	if (document.gen.chxbxc2.checked != "")
	{
		var c2crc = form.c2crc.value;
		if (c2crc.length < 7) c2crc = "0";

		form.fbagen.value += c2romname + ",1," + C2hexedsize + "," + c2crc +  "," + c1swap + "\n";
	}

//--------- C3 Output ---------//

	var c2swap = "0";

	if ((Cs_swapped != 0) && (document.gen.swapc.checked != "") && (form.c3size.value == "2097152") && (form.c4size.value == "2097152"))
	{
		if ((document.gen.chxbxc3.checked != "")&&(document.gen.chxbxc4.checked != ""))
		{
			c2swap = "2";
		}
	}

	if (document.gen.chxbxc3.checked != "")
	{
		var c3crc = form.c3crc.value;
		if (c3crc.length < 7) c3crc = "0";

		form.fbagen.value += c3romname + "," + C2total + "," + C3hexedsize + "," + c3crc + "," + c2swap + "\n";
	}

//--------- C4 Output ---------//

	if (document.gen.chxbxc4.checked != "")
	{
		var c4crc = form.c4crc.value;
		if (c4crc.length < 7) c4crc = "0";

		form.fbagen.value += c4romname + "," + c3total + "," + C4hexedsize + "," + c4crc + "," + c2swap + "\n";
	}

//------- C5-C8 Output -------//

	for (var i = 5; i < 9; i++)
	{
		if (form["chxbxc" + i].checked != false)
		{
			var c_crc = form["c" + i +"crc"].value;
			if (c_crc.length < 7) c_crc = "0";

			var name = c5romname;
			var size = C5hexedsize;
			var offset = C4total;
			if (i == 6) {name = c6romname; offset = C5total; size = C6hexedsize;}
			if (i == 7) {name = c7romname; offset = C6total; size = C7hexedsize;}
			if (i == 8) {name = c8romname; offset = C7total; size = C8hexedsize;}

			form.fbagen.value += name + "," + offset + "," + size + "," + c_crc +  ",0\n";
		}
	}

//--------- Swap C  ----------//

	if ((document.gen.swapc.checked != "") && (form.c1size.value == "2097152") && (form.c2size.value == "2097152"))
	{
		if ((document.gen.chxbxc5.checked == "") && (document.gen.chxbxc6.checked == "") && (document.gen.chxbxc7.checked == "") && (document.gen.chxbxc8.checked == ""))
		{
			if ((document.gen.chxbxc3.checked != "") && (document.gen.chxbxc4.checked != ""))		 
    			{
 				if ((form.setname.value == "wh1") || (form.setname.value == "wh1h"))
				{
					form.fbagen.value +=",400000,100000,0,0\n";
				}
				if ((form.setname.value == "aof") || (form.setname.value == "fatfury2") || (form.setname.value == "kotm2"))
				{
					form.fbagen.value +=",400000,200000,0,0\n";
				}
 				if ((form.setname.value == "3countb") || (form.setname.value == "sengoku2"))
				{
					form.fbagen.value +=",600000,200000,0,0\n";
				}
			}
			if ((document.gen.chxbxc3.checked == "") && (document.gen.chxbxc4.checked == ""))		 
    			{
 				if ((form.setname.value == "ssideki") || (form.setname.value == "viewpoin"))
				{
					form.fbagen.value +=",400000,100000,0,0\n";
				}
			}
 		}
	}

//------- Footer Label --------//

	form.fbagen.value +="\n[System]\n"

//---------- Footer -----------//

 	// This is the Unique Id. number for each game. You can find it at offset 0x108 of most P roms.
	form.fbagen.value +="CartridgeID: ";

	if (form.cartidn.value == "")
	{
	//	form.fbagen.value +="0";
		var toslice = form.p1name.value;
		toslice = toslice.slice(0,4);
		toslice = toslice.replace(/-/gi, "");
		toslice = toslice.replace(/_/gi, "");
		form.fbagen.value += toslice;
	} else {
		form.fbagen.value +=form.cartidn.value;
	}

	form.fbagen.value +="\nGfxCrypt: " + criptsel + "\n";
	form.fbagen.value +="GfxKey: " + gfxkey + "\n";

	//  This section is to deal with JockeyGP and Vliner's butlayout numbers.
	//  While all other neogeo games are 9, Jockeygp is 7 and Vliner is 8

	if (form.gambling.checked != "")
	{
		var find_name_letter = form.setname.value.slice(0,1);

		if (find_name_letter.toLowerCase() == "j")
		{
			var butlayout = "7";
		}
		if (find_name_letter.toLowerCase() == "v")
		{
			var butlayout = "8";
		}
	} else {
		var butlayout = "9";
	}

	form.fbagen.value +="ButLayout: " + butlayout + "\n"; 
	form.fbagen.value +="Fix: ";

	if (form.nebfixn.value != "")
	{
		form.fbagen.value +=form.nebfixn.value;
	} else {
		form.fbagen.value +="0";
	}

	form.fbagen.value +="\n\n%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%";
}





























	/*------------------------------------------------------------------------------------*\
	|					 					       |
	| All of the following code is for outputting MAME drivers.   It is by far the most    |
	| incomplete of all of the functions of the Generator.  The drivers produced by this   |
	| function may or may not work.  If there are any bugs, please inform me!	       |
	|										       |
	\*------------------------------------------------------------------------------------*/


if (form.picker.value == "mame")
{
	var mamebios="neogeo,";
	var gameb="B";
	var criptsel = "";

	if ((form.criptsel.value == " | HARDWARE_SNK_ENCRYPTED_A") && (document.gen.GfxKey.value !=""))
	{
		var criptsel = "	kof99_neogeo_gfx_decrypt(0x" + form.GfxKey.value + ");\n";
	}
	if ((form.criptsel.value == " | HARDWARE_SNK_ENCRYPTED_B") && (document.gen.GfxKey.value !=""))
	{
		var criptsel = "	kof2000_neogeo_gfx_decrypt(0x" + form.GfxKey.value + ");\n";
	}

	form.fbagen.value = document.lang.mmtxt5.value + "\n\n";
	form.fbagen.value +="ROM_START( " + form.setname.value + " )\n";

/*----------------------------- P Math ----------------------------------*/

	var P1=eval(form.p1size.value);
	var P2=eval(0);
	var P3=eval(0);

	if (document.gen.chxbxp2.checked != "")
		var P2=eval(form.p2size.value);
	if (document.gen.chxbxp3.checked != "")
		var P3=eval(form.p3size.value);

	var ptotal=toHex(P1+P2+P3);

	if ((P1+P2) <= "1048576")
		var ptotal=toHex(1048576);

	var p1zero="000000";

	/* enable Swap P */
	if ((document.gen.swapp.checked != "") && (document.gen.p1size.value == "2097152") && (document.gen.chxbxp2.checked == ""))
	{
		var p1zero="100000";
		var P1hexedsize = "100000";
		var SWAPPEN = "1";
		if (document.gen.setname.value == "twinspri")
		{
			var ptotal="400000";
		}
	}

	if ((form.gambling.checked != "") && (document.gen.chxbxp2.checked == "") && (P1hexedsize == "100000"))
	{
		var ptotal = "200000";
	}

/*-------------------------- Sha1 Stuff ---------------------------------*/

	var p1sha1 = "";
	var p2sha1 = "";
	var p3sha1 = "";
	var s1sha1 = "";
	var c1sha1 = "";
	var c2sha1 = "";
	var c3sha1 = "";
	var c4sha1 = "";
	var c5sha1 = "";
	var c6sha1 = "";
	var p1sha1 = "";
	var c7sha1 = "";
	var c8sha1 = "";
	var m1sha1 = "";
	var p1sha1 = "";
	var v1sha1 = "";
	var v2sha1 = "";
	var v3sha1 = "";
	var v4sha1 = "";
	var v5sha1 = "";
	var m1dsha1 = "";

	var sha1a =" SHA1(";
	var sha1b =")";

	if (document.gen.usesha.value != "")
	{
		if (document.gen.p1sha1.value != "") p1sha1 = sha1a + document.gen.p1sha1.value + sha1b;
  		if (document.gen.p2sha1.value != "") p2sha1 = sha1a + document.gen.p2sha1.value + sha1b;
  		if (document.gen.p3sha1.value != "") p3sha1 = sha1a + document.gen.p3sha1.value + sha1b;
		if (document.gen.s1sha1.value != "") s1sha1 = sha1a + document.gen.s1sha1.value + sha1b;
		if (document.gen.c1sha1.value != "") c1sha1 = sha1a + document.gen.c1sha1.value + sha1b;
		if (document.gen.c2sha1.value != "") c2sha1 = sha1a + document.gen.c2sha1.value + sha1b;
		if (document.gen.c3sha1.value != "") c3sha1 = sha1a + document.gen.c3sha1.value + sha1b;
		if (document.gen.c4sha1.value != "") c4sha1 = sha1a + document.gen.c4sha1.value + sha1b;
		if (document.gen.c5sha1.value != "") c5sha1 = sha1a + document.gen.c5sha1.value + sha1b;
		if (document.gen.c6sha1.value != "") c6sha1 = sha1a + document.gen.c6sha1.value + sha1b;
 		if (document.gen.c7sha1.value != "") c7sha1 = sha1a + document.gen.c7sha1.value + sha1b;
		if (document.gen.c8sha1.value != "") c8sha1 = sha1a + document.gen.c8sha1.value + sha1b;
  		if (document.gen.m1dsha1.value != "") m1dsha1 = sha1a + document.gen.m1dsha1.value + sha1b;
  		if (document.gen.m1sha1.value != "") m1sha1 = sha1a + document.gen.m1sha1.value + sha1b;
  		if (document.gen.v1sha1.value != "") v1sha1 = sha1a + document.gen.v1sha1.value + sha1b;
  		if (document.gen.v2sha1.value != "") v2sha1 = sha1a + document.gen.v2sha1.value + sha1b;
		if (document.gen.v3sha1.value != "") v3sha1 = sha1a + document.gen.v3sha1.value + sha1b;
		if (document.gen.v4sha1.value != "") v4sha1 = sha1a + document.gen.v4sha1.value + sha1b;
		if (document.gen.v5sha1.value != "") v5sha1 = sha1a + document.gen.v5sha1.value + sha1b;
	}

	var crc1val="CRC(";
	var crc2val=")";

	var p1crc = mame_crc(form.p1crc.value, crc1val, crc2val, 7);
	var p2crc = mame_crc(form.p2crc.value, crc1val, crc2val, 7);
	var p3crc = mame_crc(form.p3crc.value, crc1val, crc2val, 7);
	var s1crc = mame_crc(form.s1crc.value, crc1val, crc2val, 7);
	var m1crc = mame_crc(form.m1crc.value, crc1val, crc2val, 7);
	var m1dcrc = mame_crc(form.m1dcrc.value, crc1val, crc2val, 7);
	var v1crc = mame_crc(form.p1crc.value, crc1val, crc2val, 7);
	var v2crc = mame_crc(form.v2crc.value, crc1val, crc2val, 7);
	var v3crc = mame_crc(form.v3crc.value, crc1val, crc2val, 7);
	var v4crc = mame_crc(form.v4crc.value, crc1val, crc2val, 7);
	var v5crc = mame_crc(form.v5crc.value, crc1val, crc2val, 7);
	var c1crc = mame_crc(form.c1crc.value, crc1val, crc2val, 7);
	var c2crc = mame_crc(form.c2crc.value, crc1val, crc2val, 7);
	var c3crc = mame_crc(form.c3crc.value, crc1val, crc2val, 7);
	var c4crc = mame_crc(form.c4crc.value, crc1val, crc2val, 7);
	var c5crc = mame_crc(form.c5crc.value, crc1val, crc2val, 7);
	var c6crc = mame_crc(form.c6crc.value, crc1val, crc2val, 7);
	var c7crc = mame_crc(form.c7crc.value, crc1val, crc2val, 7);
	var c8crc = mame_crc(form.c8crc.value, crc1val, crc2val, 7);


/*----------------------------- P ROMs ----------------------------------*/

	form.fbagen.value +="	ROM_REGION( 0x" + ptotal + ", REGION_CPU1, 0 )\n";

	if (document.gen.chxbxp1.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_WORD_SWAP( \"" + p1romname + "\", 0x" + p1zero + ", 0x" + P1hexedsize + ", " + p1crc + p1sha1 + " )\n";
	}

	if ((form.gambling.checked != "") && (document.gen.chxbxp2.checked == "") && (P1hexedsize == "100000"))
	{
		form.fbagen.value += "	ROM_FILL( 				0x100000, 0x100000, 0xFF )\n";
	}

	if (SWAPPEN == "1")
	{
		form.fbagen.value +="	ROM_CONTINUE(						0x000000, 0x100000 )\n"
	}

	if (document.gen.chxbxp2.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_WORD_SWAP( \"" + p2romname + "\", 0x" + P1hexedsize + ", 0x" + P2hexedsize + ", " + p2crc + p2sha1 + " )\n";
	}

	if (document.gen.chxbxp3.checked != "")
	{
		var nbp3sze=eval(form.p1size.value)+eval(form.p2size.value);
		nbp3sze=toHex(nbp3sze);

		form.fbagen.value +="	ROM_LOAD16_WORD_SWAP( \"" + p3romname + "\", 0x" + nbp3sze + ", 0x" + P3hexedsize + ", " + p3crc + p3sha1 + " )\n";
	}

	form.fbagen.value +="\n";

/*----------------------------- S ROM _----------------------------------*/

	var ssize = "128";
	var s_rom_written = 0;

	if ((document.gen.chxbxs1.checked != "") && ((form.criptsel.value == "") || (form.GfxKey.value == "")))
	{
		if (form.s1size.value == 32768)  ssize="32";
		if (form.s1size.value == 65536)  ssize="64";
		if (form.s1size.value == 131072) ssize="128";
		if (form.s1size.value <= 131072)
		{
			form.fbagen.value +="	NEO_SFIX_" + ssize + "K( \"" + s1romname + "\", " + s1crc + s1sha1 + " )\n\n";
			s_rom_written = 1;
		}
	}

	if (s_rom_written != 1)
	{
		var s1esha1 = "";
		var s1size4mame = S1hexedsize;
		var snotesmame = "";
		if (document.gen.chxbxs1.checked == "") s1size4mame = "20000";
		if (document.gen.textromfix.checked != "") s1size4mame = "80000";
		if ((document.gen.textromfix.checked != "")||((document.gen.chxbxs1.checked != "")&&(form.s1size.value < 262144))) snotesmame = " /* larger char set */ "

		if (document.gen.chxbxs1.checked == "")
			form.fbagen.value +="	/* The Encrypted Boards do _not_ have an s1 rom, data for it comes from the Cx ROMs */\n"

		form.fbagen.value +="	ROM_REGION( 0x" + s1size4mame + ", REGION_GFX1, 0 )" + snotesmame + "\n"

		if (document.gen.chxbxs1.checked != "")
			form.fbagen.value += "	ROM_LOAD( \"" + s1romname + "\",		0x000000, 0x" + S1hexedsize + ", " + s1crc + " )\n";
		else
			form.fbagen.value +="	ROM_FILL(                 0x000000, 0x" + s1size4mame + ", 0 )\n"

		form.fbagen.value +="	ROM_REGION( 0x20000, REGION_GFX2, 0 )\n"

		if (document.gen.usesha.value != "")
		{
			s1esha1 = sha1a + sfixsha + sha1b;
		}

		form.fbagen.value +="	ROM_LOAD( \"sfix.sfx\",  0x000000, 0x20000, " + crc1val + sfixcrc + crc2val + s1esha1 + " )\n\n"
	}


/*------------------------------ M ROM ----------------------------------*/

	if (form.m1dsize.value == "65536")
		var msize="64";
	if (form.m1dsize.value == "131072")
		var msize="128";
	if (form.m1dsize.value == "262144")
		var msize="256";
	if (form.m1dsize.value == "524288")
		var msize="512";

	if (document.gen.chxbxm1.checked != "")
	{
		form.fbagen.value += "	\/* The M1 ROM is encrypted, we load it here for reference and replace it with a decrypted version *\/\n";
		form.fbagen.value += "	ROM_REGION( 0x" + M1hexedsize + ", REGION_USER4, 0 )\n";
		form.fbagen.value += "	ROM_LOAD( \"" + m1romname + "\", 0x00000, 0x" + M1hexedsize + ", " + m1crc + m1sha1 + " )\n";
	}

	form.fbagen.value +="	NEO_BIOS_SOUND_" + msize + "K( \"" + m1dromname + "\", " + m1dcrc + m1dsha1 + " )\n\n";


	/*-----------------------------------------------------------------------*\
	|  This section is to deal with games that have Region_Sound2 roms such   |
	|  as irrmaze, minasan, joyjoy, nam1975, etc.                             |
	|  This is only activated if the rom's name equals exactly what is below  |
	\*-----------------------------------------------------------------------*/

	var whichVvalue = "0";

	if ((form.setname.value == "irrmaze")||(form.setname.value == "minasan")||
	    (form.setname.value == "joyjoy") ||(form.setname.value == "nam1975")||
	    (form.setname.value == "maglord")||(form.setname.value == "maglordh")||
	    (form.setname.value == "tpgolf"))
	{
		whichVvalue = "1";
	}


	if ((form.setname.value == "superspy")||(form.setname.value == "gpilots")||
	    (form.setname.value == "lbowling")||(form.setname.value == "ncombat")||
	    (form.setname.value == "mahretsu"))
	{
		whichVvalue = "2";
	}

	if ((form.setname.value == "ncombat")||(form.setname.value == "ncombata"))
	{
		whichVvalue = "3";
	}
	if ((form.setname.value == "bstars")||(form.setname.value == "cyberlip"))
	{
		whichVvalue = "4";
	}

	/*-----------------------------------------------------------------------*\
	|  This section is to deal with games that only have Region_Sound1 roms   |
	|  This covers most (~95%) of all neo-geo roms			 	  |
	\*-----------------------------------------------------------------------*/


/*----------------------------- V Math ----------------------------------*/

	var v1zero="000000";

	if ((document.gen.swapv.checked != "") && (document.gen.chxbxv3.checked == "") && (V2hexedsize == "200000") && (V1hexedsize == "200000"))
	{
		var v1zero="200000";
	}

	var v1=eval(form.v1size.value);

	if (document.gen.chxbxv2.checked != "")
	{
		var v2=eval(form.v2size.value);
	} else {
		var v2=eval(0);
	}

	var v2total=toHex(v1+v2)

	if (document.gen.chxbxv3.checked != "")
	{
		var v3=eval(form.v3size.value);
	} else {
		var v3=eval(0);
	}

	var v3total=toHex(v1+v2+v3);

	if (document.gen.chxbxv4.checked != "")
	{
		var v4=eval(form.v4size.value);
	} else {
		var v4=eval(0);
	}

	if (document.gen.chxbxv5.checked != "")
	{
		var v5=eval(form.v5size.value);
	} else {
		var v5=eval(0);
	}

	var v4total=toHex(v1+v2+v3+v4);
	var v5total=toHex(v1+v2+v3+v4+v5);

	if ((document.gen.swapv.checked != "") && (document.gen.chxbxv3.checked == "") && (V1hexedsize == "200000") && (V2hexedsize == "200000"))
	{
		var v5total=toHex(v1+v2+v3+v4+v5+2097152);
	}

/*---------------------------- Start V ----------------------------------*/

	if (whichVvalue == "1")
		var v5total = V1hexedsize;

	if (whichVvalue == "2")
		var v5total = v2total;

	if (whichVvalue == "3")
		var v5total = v3total;

	if (whichVvalue == "4")
		var v5total = v4total;

	form.fbagen.value +="	ROM_REGION( 0x" + v5total + ", REGION_SOUND1, ROMREGION_SOUNDONLY )\n";

/*----------------------------- V ROMs ----------------------------------*/

	if (document.gen.chxbxv1.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD( \"" + v1romname + "\", 0x" + v1zero + ", 0x" + V1hexedsize + ", " + v1crc + v1sha1 + " )\n";
	}

/*---------------------------------*/

	if ((document.gen.swapv.checked != "") && (document.gen.chxbxv3.checked == "") && (V1hexedsize == "200000") && (V2hexedsize == "200000"))
	{
		form.fbagen.value +="	ROM_CONTINUE(			  0x000000, 0x200000 )\n"
	}

	if (document.gen.chxbxv2.checked != "")
	{
		var v2totalswapv = V1hexedsize;

		if ((document.gen.swapv.checked != "") && (document.gen.chxbxv3.checked == "") && (V2hexedsize == "200000") && (V1hexedsize == "200000"))
		{
			var v2totalswapv = "400000"
		}
		if (whichVvalue == "1")
		{
			var v2totalswapv = v1zero;
			var v2total = V2hexedsize;
			var v3total = toHex(v2+v3);
			var v4total = toHex(v2+v3+v4);
			var v5total=toHex(v2+v3+v4+v5);

			form.fbagen.value +="\n	ROM_REGION( 0x" + v5total + ", REGION_SOUND2, ROMREGION_SOUNDONLY )\n";
		}

		form.fbagen.value +="	ROM_LOAD( \"" + v2romname + "\", 0x" + v2totalswapv + ", 0x" + V2hexedsize + ", " + v2crc + v2sha1 + " )\n";
	}

/*---------------------------------*/

	if (document.gen.chxbxv3.checked != "")
	{
		if (whichVvalue == "2")
		{
			var v2total = v1zero;
			var v3total = V4hexedsize;
			var v4total = toHex(v3+v4);
			var v5total=toHex(v3+v4+v5);

			form.fbagen.value +="\n	ROM_REGION( 0x" + v5total + ", REGION_SOUND2, ROMREGION_SOUNDONLY )\n";
		}

		form.fbagen.value +="	ROM_LOAD( \"" + v3romname + "\", 0x" + v2total + ", 0x" + V3hexedsize + ", " + v3crc + v3sha1 + " )\n";
	}

/*---------------------------------*/

	if (document.gen.chxbxv4.checked != "")
	{
		if (whichVvalue == "3")
		{
			var v3total = v1zero;
			var v4total = V4hexedsize;
			var v5total = toHex(v4+v5);

			form.fbagen.value +="\n	ROM_REGION( 0x" + v5total + ", REGION_SOUND2, ROMREGION_SOUNDONLY )\n";
		}

		form.fbagen.value +="	ROM_LOAD( \"" + v4romname + "\", 0x" + v3total + ", 0x" + V4hexedsize + ", " + v4crc + v4sha1 + " )\n";
	}

/*---------------------------------*/

	if (document.gen.chxbxv5.checked != "")
	{
		if (whichVvalue == "4")
		{
			form.fbagen.value +="\n	ROM_REGION( 0x" + V5hexedsize + ", REGION_SOUND2, ROMREGION_SOUNDONLY )\n";

			var v4total = v1zero;
		}

		form.fbagen.value +="	ROM_LOAD( \"" + v5romname + "\", 0x" + v4total + ", 0x" + V5hexedsize + ", " + v5crc + v5sha1 + " )\n";
	}

/*---------------------------------*/

	if (whichVvalue == "0")
	{
		form.fbagen.value +="	\n	NO_DELTAT_REGION\n";
	}

	form.fbagen.value +="\n";


/*------- Enable Swap C -----------*/

	if (document.gen.swapc.checked != "")
	{
		if ((document.gen.chxbxc5.checked == "") && (document.gen.chxbxc6.checked == "") && (document.gen.chxbxc7.checked == "") && (document.gen.chxbxc8.checked == ""))
		{
			if ((document.gen.c1size.value == "2097152") && (document.gen.c2size.value == "2097152") && (document.gen.chxbxc2.checked !=""))
			{
				var enswapc = "1";
			}	
		}
	}

/*----------------------------- C Math ----------------------------------*/

	if (document.gen.chxbxc1.checked != "")
	{
		var C1=eval(form.c1size.value);
	} else {
		var C1=eval(0);
	}

	if (document.gen.chxbxc2.checked != "")
	{
		var C2=eval(form.c2size.value);
	} else {
		var C2=eval(0);
	}

/*---------------------------------*/

	var C2total=toHex(C1+C2);
	var Ct1=((C1+C2)/16);
	var c3total=(toHex(Ct1)+1);


/*---------------------------------*/

	if (document.gen.chxbxc3.checked != "")
	{
		var C3=eval(form.c3size.value);
	} else {
		var C3=eval(0);
	}

	if (document.gen.chxbxc4.checked != "")
	{
		var C4=eval(form.c4size.value);
	} else {
		var C4=eval(0);
	}

/*---------------------------------*/

	var C4total=toHex(C1+C2+C3+C4);
	var Ct2=((C1+C2+C3+C4)/16);
	var C5total=(toHex(Ct2)+1);

/*---------------------------------*/

	if (document.gen.chxbxc5.checked != "")
	{
		var C5=eval(form.c5size.value);
	} else {
		var C5=eval(0);
	}

	if (document.gen.chxbxc6.checked != "")
	{
		var C6=eval(form.c6size.value);
	} else {
		var C6=eval(0);
	}

/*---------------------------------*/


	var C6total=toHex(C1+C2+C3+C4+C5+C6);
	var Ct3=((C1+C2+C3+C4+C5+C6)/16);
	var C7total=(toHex(Ct3)+1);

	if (document.gen.chxbxc7.checked != "")
	{
		var C7=eval(form.c7size.value);
	} else {
		var C7=eval(0);
	}

	if (document.gen.chxbxc8.checked != "")
	{
		var C8=eval(form.c8size.value);
	} else {
		var C8=eval(0);
	}

	var Ctotal=toHex(C1+C2+C3+C4+C5+C6+C7+C8);


	/* Swap C stuff */
	if (enswapc == "1")
	{
		C1hexedsize = "100000";
		C2hexedsize = "100000";

		if (document.gen.c3size.value == "2097152")
			C3hexedsize = "100000";

		if (document.gen.c4size.value == "2097152")
			C4hexedsize = "100000";

		if ((document.gen.chxbxc3.checked != "") && (document.gen.chxbxc4.checked != ""))
		{
			if ((document.gen.c3size.value == "524288") && (document.gen.c4size.value == "524288"))
			{
				Ctotal="600000";
			}
 		}

		if ((document.gen.chxbxc3.checked == "") && (document.gen.chxbxc4.checked == ""))
		{
			Ctotal="600000";
		}

		var C2total=eval(200000);
		var c3total=eval(200001);
	}


/*----------------------------- C ROMs ----------------------------------*/

	form.fbagen.value +="	ROM_REGION( 0x" + Ctotal + ", REGION_GFX3, 0 )\n";

/*---------------------------------*/

	if (C1+C2+C3+C4+C5+C6+C7+C8 <= 15728640)
	{
		var c1zero = '000000';
	} else {
		var c1zero = '0000000';
	}

	form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c1romname + "\", 0x" + c1zero + ", 0x" + C1hexedsize + ", " + c1crc + c1sha1 + " )\n";

	if (enswapc == "1")
	{
		form.fbagen.value +="	ROM_CONTINUE(      			   0x400000, 0x100000 )\n"
	}

	if (c1zero == '0000000')
		var c2zero = '0000001'
	if (c1zero == '000000')
		var c2zero = '000001'

	if (document.gen.chxbxc2.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c2romname + "\", 0x" + c2zero + ", 0x" + C2hexedsize + ", " + c2crc + c2sha1 + " )\n";
	}

	if (enswapc == "1")
	{
		form.fbagen.value +="	ROM_CONTINUE(      			   0x400001, 0x100000 )\n"
	}

/*---------------------------------*/

	if (document.gen.chxbxc3.checked != "")
	{
  		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c3romname + "\", 0x" + C2total + ", 0x" + C3hexedsize + ", " + c3crc + c3sha1 + " )\n";

		if ((enswapc == "1") && (document.gen.c3size.value == "2097152"))
		{
			form.fbagen.value +="	ROM_CONTINUE(      			   0x600000, 0x100000 )\n"
		}
	}

/*---------------------------------*/

	if (document.gen.chxbxc4.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c4romname + "\", 0x" + c3total + ", 0x" + C4hexedsize + ", " + c4crc + c4sha1 + " )\n";

		if ((enswapc == "1") && (document.gen.c4size.value == "2097152"))
		{
			form.fbagen.value +="	ROM_CONTINUE(      			   0x600001, 0x100000 )\n"
		}
	}

/*---------------------------------*/

	if (document.gen.chxbxc5.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c5romname + "\", 0x" + C4total + ", 0x" + C5hexedsize + ", " + c5crc + c5sha1 + " )\n";
	}

/*---------------------------------*/

	if (document.gen.chxbxc6.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c6romname + "\", 0x" + C5total + ", 0x" + C6hexedsize + ", " + c6crc + c6sha1 + " )\n";
	}

/*---------------------------------*/

	if (document.gen.chxbxc7.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c7romname + "\", 0x" + C6total + ", 0x" + C7hexedsize + ", " + c7crc + c7sha1 + " )\n";
	}

/*---------------------------------*/

	if (document.gen.chxbxc8.checked != "")
	{
		form.fbagen.value +="	ROM_LOAD16_BYTE( \"" + c8romname + "\", 0x" + C7total + ", 0x" + C8hexedsize + ", " + c8crc + c8sha1 + " )\n";
	}

	form.fbagen.value +="ROM_END";

/*----------------------------- Init Section ----------------------------*/

	var show_mame_init = 0;
	var encryption_stuff = "";
	var fix_bank = "";
	var extract_sdata = "";

	if (criptsel !="")
	{
		show_mame_init = 1;
		fix_bank = "	neogeo_fix_bank_type = 1;\n"
		encryption_stuff = criptsel;
	}
	if (document.gen.alttxt.checked != "")
	{
		show_mame_init = 1;
	
		if (document.gen.alttxt.value == " | HARDWARE_SNK_ALTERNATE_TEXT")
		{
			fix_bank = "	neogeo_fix_bank_type = 2;\n"
		}
	}

	if ((form.criptsel.value == "") && (document.gen.chxbxs1.checked == ""))
	{
		show_mame_init = 1;

		extract_sdata =  "	/* the S data comes from the end fo the C data */\n";
		extract_sdata += "	int i;\n	UINT8 *src = memory_region(REGION_GFX3) + memory_region_length(REGION_GFX3) - 0x" + s1size4mame + ";\n";
		extract_sdata += "	UINT8 *dst = memory_region(REGION_GFX1);\n\n	for (i = 0; i < 0x" + s1size4mame + "; i++)\n";
		extract_sdata += "		dst[i] = src[(i & 0x1ffe0) + ((i & 7) << 2) + ((~i & 8) >> 2) + ((i & 0x10) >> 4)];\n\n";
	}

	if (document.gen.gambling.checked !="")
	{
		show_mame_init = 1;
	}

	if (show_mame_init != 0)
	{
  		form.fbagen.value +="\n\n\n" + document.lang.mmtxt2.value + " \n\n";

		if (document.gen.gambling.checked !="")
		{
			form.fbagen.value +="static data16_t neogeo_sram16_2[0x2000];\n\n";
			form.fbagen.value +="READ16_HANDLER( neogeo_sram16_2_r )\n{\n        return neogeo_sram16_2[offset];\n}\n\n";
			form.fbagen.value +="WRITE16_HANDLER( neogeo_sram16_2_w )\n{\n        COMBINE_DATA(&neogeo_sram16_2[offset]);\n}\n\n";
		}

		form.fbagen.value +="DRIVER_INIT( " + form.setname.value + " )\n{\n";

		form.fbagen.value += extract_sdata;
		form.fbagen.value += fix_bank;
		form.fbagen.value += encryption_stuff;

		if (document.gen.gambling.checked !="")
		{
			form.fbagen.value += "	install_mem_read16_handler(0, 0x200000, 0x201FFF, neogeo_sram16_2_r);\n";
 			form.fbagen.value += "	install_mem_write16_handler(0, 0x200000, 0x201FFF, neogeo_sram16_2_w);\n\n";
		}

		form.fbagen.value +="	init_neogeo();\n}"
	}


/*----------------------------- End Stuff -------------------------------*/

	if (document.gen.sram.checked != "")
	{
		form.fbagen.value +="\n\n\n" + document.lang.mmtxt3.value + " NEOGEO.C (src/machine/)\n" + document.lang.mmtxt4.value + " \n";
		form.fbagen.value +="\n			!strcmp(Machine->gamedrv->name," + form.setname.value + ") ||"
	}

	form.fbagen.value +="\n\n\n" + document.lang.mmtxt1.value + " NEOGEO.C (src/drivers/)\n\n";

	if(form.parentname.value =="")
	{
		var parentname ="neogeo";
	}
	if ((form.bdfclone.value != "") && (form.parentname.value !=""))
	{
		var parentname =form.parentname.value;
	}
	if ((form.bdfclone.value == "") && (form.parentname.value !=""))
	{
		var parentname = "neogeo";
	}

	var initname = "neogeo";

	if (show_mame_init != 0)
	{
		var initname = form.setname.value;
	}

	// mjneogeo irrmaze -->trackball

	var controls = "neogeo";
	if (form.controls.value == "neotrackball")
		var controls = "irrmaze";
	if (form.controls.value == "neomahjong")
		var controls = "mjneogeo";
	if (form.controls.value == "neopaddle")
		var controls = "neogeo";

	var working = "X";
	var working2 = ", GAME_NOT_WORKING";
	if (document.gen.works.checked != "")
	{
		var working = "";
		var working2 = "";
	}

	if (form.gambling.checked != "")
	{
		var find_name_letter = form.setname.value.slice(0,1);
		if (find_name_letter.toLowerCase() == "v")
		{
			var working = "X";
			var working2 = ", GAME_NOT_WORKING";
		}
	}

	var prototype = "";
	if (document.gen.proto.checked != "")
		var prototype = " (Prototype)";

	var bootleg = "";
	if (document.gen.bootleg.checked != "")
		var bootleg = " (Bootleg)";

	var machine = document.gen.machine.value;

	if (document.gen.setname.value == "mosyougi")
		machine = "raster_busy"


	form.fbagen.value +="GAME" + gameb + working + "( " + form.yearname.value + ", " + form.setname.value + ", " + parentname + ", " + mamebios + " " + machine + ", " + controls + ",  " + initname + ",   ROT0, \"" + form.devname.value + "\", \"" + form.realname.value + prototype + bootleg + "\"" + working2 + " )";
	form.fbagen.value +="\n\n\n" + document.lang.mmtxt1.value + " DRIVER.C (src/)\n\n";

	var cartidmame = ""
	if (form.cartidn.value != "")
		var cartidmame = form.cartidn.value + " ";

	form.fbagen.value +="	DRIVER( " + form.setname.value + " )	/* " + cartidmame + "(c) " + form.yearname.value + " " + form.devname.value + " */";

}



	/*-------------------------------------------------------------------------------------*\
	|					 					  	|
	| All of the following code is for outputting CLRMAMEPro dats.   This is actually 	|
	| a fairly complete module, but there are a few vital pieces missing.  Maybe I will	|
	| improve on it someday...							   	|
	|										 	|
	\*-------------------------------------------------------------------------------------*/


if (form.picker.value == "cl")
{
	var is_clone = 0;

	form.fbagen.value = "game (\n";
	form.fbagen.value += "\tname " + form.setname.value + "\n";
	form.fbagen.value +=  "\tdescription \"" + form.realname.value + "\"\n";

	if ((form.bdfclone.value != "")&&(form.parentname.value != ""))
	{
		is_clone = 1;
		form.fbagen.value += "\tromof " + form.parentname.value + "\n"
	} else {

		form.fbagen.value += "\tromof neogeo\n";
	}

/*	// Do neo-geo parent (bios) files
	rom ( name 000-lo.lo merge 000-lo.lo size 65536 crc e09e253c )
	rom ( name sp-s2.sp1 merge sp-s2.sp1 size 131072 crc 9036d879 )
	rom ( name sfix.sfx merge sfix.sfx size 131072 crc 354029fc )
*/

	form.fbagen.value += clr_gen(form, "p1", p1romname, is_clone);
	form.fbagen.value += clr_gen(form, "p2", p2romname, is_clone);

	form.fbagen.value += clr_gen(form, "s1", s1romname, is_clone);

	for (var i = 1; i < 9; i++)
	{
		if (form["chxbxc" + i].checked != false)
		{
			var name = c1romname;
			if (i == 2) name = c2romname;
			if (i == 3) name = c3romname;
			if (i == 4) name = c4romname;
			if (i == 5) name = c5romname;
			if (i == 6) name = c6romname;
			if (i == 7) name = c7romname;
			if (i == 8) name = c8romname;

			form.fbagen.value += clr_gen(form, "c"+i, name, is_clone);
		}
	}

	form.fbagen.value += clr_gen(form, "m1", m1romname, is_clone);
	form.fbagen.value += clr_gen(form, "m1d", m1dromname, is_clone);

	for (var i = 1; i < 6; i++)
	{
		if (form["chxbxv" + i].checked != false)
		{
			var name = v1romname;
			if (i == 2) name = v2romname;
			if (i == 3) name = v3romname;
			if (i == 4) name = v4romname;
			if (i == 5) name = v5romname;

			form.fbagen.value += clr_gen(form, "v"+i, name, is_clone);
		}
	}

	form.fbagen.value += ")\n";
}


	/*-------------------------------------------------------------------------------------*\
	|					 					  	|
	| All of the following code is for outputting RomCenter dats.   This is fairly	 	|
	| incomplete and I have little ambition to actually finish it.				|
	|										 	|
	\*-------------------------------------------------------------------------------------*/

if (form.picker.value == "rc")
{
	form.fbagen.value = "";
	is_clone = 0;
	var begin = "";

	begin += "";
	if ((form.bdfclone.value != "")&&(form.parentname.value != ""))
	{
		begin += form.setname.value;
	} else {
		is_clone = 1;
		begin += form.parentname.value;
	}

	form.fbagen.value ;

	// this should be parent title if clone
	//if (is_clone == 1)
	//{
	//	begin += "" + form.parenttitle.value;
	//} else {
		begin += "" + form.realname.value;
	//}
	begin += "" + form.setname.value + "" + form.realname.value + "";


	form.fbagen.value += rc_gen(form, begin, "p1", p1romname, is_clone);
	form.fbagen.value += rc_gen(form, begin, "p2", p2romname, is_clone);
	form.fbagen.value += rc_gen(form, begin, "s1", s1romname, is_clone);
	form.fbagen.value += rc_gen(form, begin, "m1d", m1dromname, is_clone);
	form.fbagen.value += rc_gen(form, begin, "m1", m1romname, is_clone);

	for (i = 1; i < 6; i++)
	{
		var type = "v" + i;
		var name = v1romname;
		if (i==2)name = v2romname;
		if (i==3)name = v3romname;
		if (i==4)name = v4romname;
		if (i==5)name = v5romname;

		form.fbagen.value += rc_gen(form, begin, type, name, is_clone);
	}

	for (i = 1; i < 9; i++)
	{
		var type = "c" + i;
		var name = c1romname;
		if (i==2)name = c2romname;
		if (i==3)name = c3romname;
		if (i==4)name = c4romname;
		if (i==5)name = c5romname;
		if (i==6)name = c6romname;
		if (i==7)name = c7romname;
		if (i==8)name = c8romname;

		form.fbagen.value += rc_gen(form, begin, type, name, is_clone);
	}


//parentnameparent titlesetname title  rom name  rom crc  size  parent name (one  if from parent, two 's if not)

// Needs to include bios files
/*
2020bb2020 Super Baseball2020bba2020 Super Baseball (set 2)000-lo.loe09e253c655362020bb000-lo.lo
2020bb2020 Super Baseball2020bba2020 Super Baseball (set 2)sp-s2.sp19036d8791310722020bbsp-s2.sp1
2020bb2020 Super Baseball2020bba2020 Super Baseball (set 2)sfix.sfx354029fc1310722020bbsfix.sfx
*/
}








//-------- Leave this alone!!!!! ---------//
}